interface FullTimeEmployee {
    empType: "FullType";
    name: string;
    annualSalary: number;
}

interface PartTimeEmployee {
    empType: "PartTime";
    name: string;
    monthlySalary: number;
}

interface ContractEmployee {
    empType: "Contractor";
    name: string;
    hourlySalary: number;
}

//using type alias
type Employee = FullTimeEmployee | PartTimeEmployee | ContractEmployee;

function getEmployeeSalary(emp: Employee): number {
    switch (emp.empType) {
        case "FullType":
            return emp.annualSalary;
        case "PartTime":
            return emp.monthlySalary;
        case "Contractor":
            return emp.hourlySalary;
        default:
            let temp: never = emp;
            return temp;
    }
}

let contractor: ContractEmployee = {empType: "Contractor", name: "Tina", hourlySalary: 34};
let sal = getEmployeeSalary(contractor);
console.log(sal);